Index: src/atom.cpp
===================================================================
--- src/atom.cpp	(revision d8b94a86944c4679c88bc250bff510f242d63309)
+++ src/atom.cpp	(revision 1907a789609146bbdebfeff09de44cb4ba21b808)
@@ -1,15 +1,15 @@
 /** \file atom.cpp
- * 
+ *
  * Function implementations for the class atom.
- * 
+ *
  */
 
 #include "molecules.hpp"
- 
+
 /************************************* Functions for class atom *************************************/
 
 /** Constructor of class atom.
  */
-atom::atom() 
+atom::atom()
 {
 	Name = NULL;
@@ -33,5 +33,5 @@
 /** Destructor of class atom.
  */
-atom::~atom() 
+atom::~atom()
 {
 	Free((void **)&Name, "atom::~atom: *Name");
@@ -58,6 +58,7 @@
  * \param AtomNo cardinal number among these atoms of the same element
  * \param *out stream to output to
+ * \param *comment commentary after '#' sign
  */
-bool atom::Output(int ElementNo, int AtomNo, ofstream *out) const
+bool atom::Output(int ElementNo, int AtomNo, ofstream *out, const char *comment) const
 {
 	if (out != NULL) {
@@ -67,5 +68,8 @@
 		if (v.Norm() > MYEPSILON)
 			*out << "\t" << scientific << setprecision(6) << v.x[0] << "\t" << v.x[1] << "\t" << v.x[2] << "\t";
-		*out << " # Number in molecule " << nr << endl;
+		if (comment != NULL)
+		  *out << " # " << comment << endl;
+		else
+		  *out << " # molecule nr " << nr << endl;
 		return true;
 	} else
@@ -85,5 +89,5 @@
 };
 
-ostream & operator << (ostream &ost, atom &a) 
+ostream & operator << (ostream &ost, atom &a)
 {
 	ost << "[" << a.Name << "|" << &a << "]";
@@ -94,5 +98,5 @@
  * \param ptr atom to compare index against
  * \return true - this one's is smaller, false - not
- */ 
+ */
 bool atom::Compare(atom &ptr)
 {
@@ -103,5 +107,5 @@
 };
 
-bool operator < (atom &a, atom &b) 
+bool operator < (atom &a, atom &b)
 {
 	return a.Compare(b);
Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision d8b94a86944c4679c88bc250bff510f242d63309)
+++ src/builder.cpp	(revision 1907a789609146bbdebfeff09de44cb4ba21b808)
@@ -55,9 +55,9 @@
 #include "molecules.hpp"
 
-/********************************************** Submenu routine **************************************/
+/********************************************* Subsubmenu routine ************************************/
 
 /** Submenu for adding atoms to the molecule.
  * \param *periode periodentafel
- * \param *mol the molecule to add to
+ * \param *molecule molecules with atoms
  */
 static void AddAtoms(periodentafel *periode, molecule *mol)
@@ -83,172 +83,175 @@
 
 	switch (choice) {
+    default:
+      cout << Verbose(0) << "Not a valid choice." << endl;
+      break;
 			case 'a': // absolute coordinates of atom
-				cout << Verbose(0) << "Enter absolute coordinates." << endl;
-				first = new atom;
-				first->x.AskPosition(mol->cell_size, false);
-				first->type = periode->AskElement();	// give type
-				mol->AddAtom(first);	// add to molecule
+        cout << Verbose(0) << "Enter absolute coordinates." << endl;
+        first = new atom;
+        first->x.AskPosition(mol->cell_size, false);
+        first->type = periode->AskElement();	// give type
+        mol->AddAtom(first);	// add to molecule
 				break;
 
 			case 'b': // relative coordinates of atom wrt to reference point
-				first = new atom;
-				valid = true;
-				do {
-					if (!valid) cout << Verbose(0) << "Resulting position out of cell." << endl;
-					cout << Verbose(0) << "Enter reference coordinates." << endl;
-					x.AskPosition(mol->cell_size, true);
-					cout << Verbose(0) << "Enter relative coordinates." << endl;
-					first->x.AskPosition(mol->cell_size, false);
-					first->x.AddVector((const Vector *)&x);
-					cout << Verbose(0) << "\n";
-				} while (!(valid = mol->CheckBounds((const Vector *)&first->x)));
-				first->type = periode->AskElement();	// give type
-				mol->AddAtom(first);	// add to molecule
+        first = new atom;
+        valid = true;
+        do {
+          if (!valid) cout << Verbose(0) << "Resulting position out of cell." << endl;
+          cout << Verbose(0) << "Enter reference coordinates." << endl;
+          x.AskPosition(mol->cell_size, true);
+          cout << Verbose(0) << "Enter relative coordinates." << endl;
+          first->x.AskPosition(mol->cell_size, false);
+          first->x.AddVector((const Vector *)&x);
+          cout << Verbose(0) << "\n";
+        } while (!(valid = mol->CheckBounds((const Vector *)&first->x)));
+        first->type = periode->AskElement();	// give type
+        mol->AddAtom(first);	// add to molecule
 				break;
 
 			case 'c': // relative coordinates of atom wrt to already placed atom
-				first = new atom;
-				valid = true;
-				do {
-					if (!valid) cout << Verbose(0) << "Resulting position out of cell." << endl;
-					second = mol->AskAtom("Enter atom number: ");
-					cout << Verbose(0) << "Enter relative coordinates." << endl;
-					first->x.AskPosition(mol->cell_size, false);
-					for (int i=NDIM;i--;) {
-						first->x.x[i] += second->x.x[i];
-					}
-				} while (!(valid = mol->CheckBounds((const Vector *)&first->x)));
-				first->type = periode->AskElement();	// give type
-				mol->AddAtom(first);	// add to molecule
+        first = new atom;
+        valid = true;
+        do {
+          if (!valid) cout << Verbose(0) << "Resulting position out of cell." << endl;
+          second = mol->AskAtom("Enter atom number: ");
+          cout << Verbose(0) << "Enter relative coordinates." << endl;
+          first->x.AskPosition(mol->cell_size, false);
+          for (int i=NDIM;i--;) {
+            first->x.x[i] += second->x.x[i];
+          }
+        } while (!(valid = mol->CheckBounds((const Vector *)&first->x)));
+        first->type = periode->AskElement();	// give type
+        mol->AddAtom(first);	// add to molecule
+        break;
+
+    case 'd': // two atoms, two angles and a distance
+        first = new atom;
+        valid = true;
+        do {
+          if (!valid) {
+            cout << Verbose(0) << "Resulting coordinates out of cell - ";
+            first->x.Output((ofstream *)&cout);
+            cout << Verbose(0) << endl;
+          }
+          cout << Verbose(0) << "First, we need two atoms, the first atom is the central, while the second is the outer one." << endl;
+          second = mol->AskAtom("Enter central atom: ");
+          third = mol->AskAtom("Enter second atom (specifying the axis for first angle): ");
+          fourth = mol->AskAtom("Enter third atom (specifying a plane for second angle): ");
+          a = ask_value("Enter distance between central (first) and new atom: ");
+          b = ask_value("Enter angle between new, first and second atom (degrees): ");
+          b *= M_PI/180.;
+          bound(&b, 0., 2.*M_PI);
+          c = ask_value("Enter second angle between new and normal vector of plane defined by first, second and third atom (degrees): ");
+          c *= M_PI/180.;
+          bound(&c, -M_PI, M_PI);
+          cout << Verbose(0) << "radius: " << a << "\t phi: " << b*180./M_PI << "\t theta: " << c*180./M_PI << endl;
+/*
+          second->Output(1,1,(ofstream *)&cout);
+          third->Output(1,2,(ofstream *)&cout);
+          fourth->Output(1,3,(ofstream *)&cout);
+          n.MakeNormalvector((const vector *)&second->x, (const vector *)&third->x, (const vector *)&fourth->x);
+          x.Copyvector(&second->x);
+          x.SubtractVector(&third->x);
+          x.Copyvector(&fourth->x);
+          x.SubtractVector(&third->x);
+
+          if (!z.SolveSystem(&x,&y,&n, b, c, a)) {
+            cout << Verbose(0) << "Failure solving self-dependent linear system!" << endl;
+            continue;
+          }
+          cout << Verbose(0) << "resulting relative coordinates: ";
+          z.Output((ofstream *)&cout);
+          cout << Verbose(0) << endl;
+          */
+          // calc axis vector
+          x.CopyVector(&second->x);
+          x.SubtractVector(&third->x);
+          x.Normalize();
+          cout << "x: ",
+          x.Output((ofstream *)&cout);
+          cout << endl;
+          z.MakeNormalVector(&second->x,&third->x,&fourth->x);
+          cout << "z: ",
+          z.Output((ofstream *)&cout);
+          cout << endl;
+          y.MakeNormalVector(&x,&z);
+          cout << "y: ",
+          y.Output((ofstream *)&cout);
+          cout << endl;
+
+          // rotate vector around first angle
+          first->x.CopyVector(&x);
+          first->x.RotateVector(&z,b - M_PI);
+          cout << "Rotated vector: ",
+          first->x.Output((ofstream *)&cout);
+          cout << endl;
+          // remove the projection onto the rotation plane of the second angle
+          n.CopyVector(&y);
+          n.Scale(first->x.Projection(&y));
+          cout << "N1: ",
+          n.Output((ofstream *)&cout);
+          cout << endl;
+          first->x.SubtractVector(&n);
+          cout << "Subtracted vector: ",
+          first->x.Output((ofstream *)&cout);
+          cout << endl;
+          n.CopyVector(&z);
+          n.Scale(first->x.Projection(&z));
+          cout << "N2: ",
+          n.Output((ofstream *)&cout);
+          cout << endl;
+          first->x.SubtractVector(&n);
+          cout << "2nd subtracted vector: ",
+          first->x.Output((ofstream *)&cout);
+          cout << endl;
+
+          // rotate another vector around second angle
+          n.CopyVector(&y);
+          n.RotateVector(&x,c - M_PI);
+          cout << "2nd Rotated vector: ",
+          n.Output((ofstream *)&cout);
+          cout << endl;
+
+          // add the two linear independent vectors
+          first->x.AddVector(&n);
+          first->x.Normalize();
+          first->x.Scale(a);
+          first->x.AddVector(&second->x);
+
+          cout << Verbose(0) << "resulting coordinates: ";
+          first->x.Output((ofstream *)&cout);
+          cout << Verbose(0) << endl;
+        } while (!(valid = mol->CheckBounds((const Vector *)&first->x)));
+        first->type = periode->AskElement();	// give type
+        mol->AddAtom(first);	// add to molecule
 				break;
 
-			case 'd': // two atoms, two angles and a distance
-				first = new atom;
-				valid = true;
-				do {
-					if (!valid) {
-						cout << Verbose(0) << "Resulting coordinates out of cell - ";
-						first->x.Output((ofstream *)&cout);
-						cout << Verbose(0) << endl;
-					}
-					cout << Verbose(0) << "First, we need two atoms, the first atom is the central, while the second is the outer one." << endl;
-					second = mol->AskAtom("Enter central atom: ");
-					third = mol->AskAtom("Enter second atom (specifying the axis for first angle): ");
-					fourth = mol->AskAtom("Enter third atom (specifying a plane for second angle): ");
-					a = ask_value("Enter distance between central (first) and new atom: ");
-					b = ask_value("Enter angle between new, first and second atom (degrees): ");
-					b *= M_PI/180.;
-					bound(&b, 0., 2.*M_PI);
-					c = ask_value("Enter second angle between new and normal vector of plane defined by first, second and third atom (degrees): ");
-					c *= M_PI/180.;
-					bound(&c, -M_PI, M_PI);
-					cout << Verbose(0) << "radius: " << a << "\t phi: " << b*180./M_PI << "\t theta: " << c*180./M_PI << endl;
-/*
-					second->Output(1,1,(ofstream *)&cout);
-					third->Output(1,2,(ofstream *)&cout);
-					fourth->Output(1,3,(ofstream *)&cout);
-					n.MakeNormalvector((const vector *)&second->x, (const vector *)&third->x, (const vector *)&fourth->x);
-					x.Copyvector(&second->x);
-					x.SubtractVector(&third->x);
-					x.Copyvector(&fourth->x);
-					x.SubtractVector(&third->x);
-
-					if (!z.SolveSystem(&x,&y,&n, b, c, a)) {
-						cout << Verbose(0) << "Failure solving self-dependent linear system!" << endl;
-						continue;
-					}
-					cout << Verbose(0) << "resulting relative coordinates: ";
-					z.Output((ofstream *)&cout);
-					cout << Verbose(0) << endl;
-					*/
-					// calc axis vector
-					x.CopyVector(&second->x);
-					x.SubtractVector(&third->x);
-					x.Normalize();
-					cout << "x: ",
-					x.Output((ofstream *)&cout);
-					cout << endl;
-					z.MakeNormalVector(&second->x,&third->x,&fourth->x);
-					cout << "z: ",
-					z.Output((ofstream *)&cout);
-					cout << endl;
-					y.MakeNormalVector(&x,&z);
-					cout << "y: ",
-					y.Output((ofstream *)&cout);
-					cout << endl;
-
-					// rotate vector around first angle
-					first->x.CopyVector(&x);
-					first->x.RotateVector(&z,b - M_PI);
-					cout << "Rotated vector: ",
-					first->x.Output((ofstream *)&cout);
-					cout << endl;
-					// remove the projection onto the rotation plane of the second angle
-					n.CopyVector(&y);
-					n.Scale(first->x.Projection(&y));
-					cout << "N1: ",
-					n.Output((ofstream *)&cout);
-					cout << endl;
-					first->x.SubtractVector(&n);
-					cout << "Subtracted vector: ",
-					first->x.Output((ofstream *)&cout);
-					cout << endl;
-					n.CopyVector(&z);
-					n.Scale(first->x.Projection(&z));
-					cout << "N2: ",
-					n.Output((ofstream *)&cout);
-					cout << endl;
-					first->x.SubtractVector(&n);
-					cout << "2nd subtracted vector: ",
-					first->x.Output((ofstream *)&cout);
-					cout << endl;
-
-					// rotate another vector around second angle
-					n.CopyVector(&y);
-					n.RotateVector(&x,c - M_PI);
-					cout << "2nd Rotated vector: ",
-					n.Output((ofstream *)&cout);
-					cout << endl;
-
-					// add the two linear independent vectors
-					first->x.AddVector(&n);
-					first->x.Normalize();
-					first->x.Scale(a);
-					first->x.AddVector(&second->x);
-
-					cout << Verbose(0) << "resulting coordinates: ";
-					first->x.Output((ofstream *)&cout);
-					cout << Verbose(0) << endl;
-				} while (!(valid = mol->CheckBounds((const Vector *)&first->x)));
-				first->type = periode->AskElement();	// give type
-				mol->AddAtom(first);	// add to molecule
-				break;
-
 			case 'e': // least square distance position to a set of atoms
-				first = new atom;
-				atoms = new (Vector*[128]);
-				valid = true;
-				for(int i=128;i--;)
-					atoms[i] = NULL;
-				int i=0, j=0;
-				cout << Verbose(0) << "Now we need at least three molecules.\n";
-				do {
-					cout << Verbose(0) << "Enter " << i+1 << "th atom: ";
-					cin >> j;
-					if (j != -1) {
-						second = mol->FindAtom(j);
-						atoms[i++] = &(second->x);
-					}
-				} while ((j != -1) && (i<128));
-				if (i >= 2) {
-					first->x.LSQdistance(atoms, i);
-
-					first->x.Output((ofstream *)&cout);
-					first->type = periode->AskElement();	// give type
-					mol->AddAtom(first);	// add to molecule
-				} else {
-					delete first;
-					cout << Verbose(0) << "Please enter at least two vectors!\n";
-				}
+        first = new atom;
+        atoms = new (Vector*[128]);
+        valid = true;
+        for(int i=128;i--;)
+          atoms[i] = NULL;
+        int i=0, j=0;
+        cout << Verbose(0) << "Now we need at least three molecules.\n";
+        do {
+          cout << Verbose(0) << "Enter " << i+1 << "th atom: ";
+          cin >> j;
+          if (j != -1) {
+            second = mol->FindAtom(j);
+            atoms[i++] = &(second->x);
+          }
+        } while ((j != -1) && (i<128));
+        if (i >= 2) {
+          first->x.LSQdistance(atoms, i);
+
+          first->x.Output((ofstream *)&cout);
+          first->type = periode->AskElement();	// give type
+          mol->AddAtom(first);	// add to molecule
+        } else {
+          delete first;
+          cout << Verbose(0) << "Please enter at least two vectors!\n";
+        }
 				break;
 	};
@@ -256,5 +259,5 @@
 
 /** Submenu for centering the atoms in the molecule.
- * \param *mol the molecule with all the atoms
+ * \param *mol molecule with all the atoms
  */
 static void CenterAtoms(molecule *mol)
@@ -314,5 +317,5 @@
 /** Submenu for aligning the atoms in the molecule.
  * \param *periode periodentafel
- * \param *mol the molecule with all the atoms
+ * \param *mol molecule with all the atoms
  */
 static void AlignAtoms(periodentafel *periode, molecule *mol)
@@ -382,5 +385,5 @@
 
 /** Submenu for mirroring the atoms in the molecule.
- * \param *mol the molecule with all the atoms
+ * \param *mol molecule with all the atoms
  */
 static void MirrorAtoms(molecule *mol)
@@ -429,5 +432,5 @@
 
 /** Submenu for removing the atoms from the molecule.
- * \param *mol the molecule with all the atoms
+ * \param *mol molecule with all the atoms
  */
 static void RemoveAtoms(molecule *mol)
@@ -487,5 +490,5 @@
 /** Submenu for measuring out the atoms in the molecule.
  * \param *periode periodentafel
- * \param *mol the molecule with all the atoms
+ * \param *mol molecule with all the atoms
  */
 static void MeasureAtoms(periodentafel *periode, molecule *mol, config *configuration)
@@ -597,5 +600,5 @@
 
 /** Submenu for measuring out the atoms in the molecule.
- * \param *mol the molecule with all the atoms
+ * \param *mol molecule with all the atoms
  * \param *configuration configuration structure for the to be written config files of all fragments
  */
